//Copyright (C) 2004, Brian Enigma <enigma at netninja.com>
//This file is part of MagicCodes.
//
//MagicCodes is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//MagicCodes is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with Foobar; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package org.ninjasoft.magiccodes.plugins;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Plugin for turning something into an MD5 hash
 * @author enigma
 */
public class Md5 implements Plugin {
	public String getName() {
		return "MD5";
	}
	public String getDescription() {
		return "Hashes the input to MD5";
	}
	public boolean usesKey() {
		return false;
	}
    public boolean isInformational() {
        return false;
    }
	public int[] doAction(int[] in, int[] key) {
        byte[] inData = new byte[in.length];
        for (int i=0; i<in.length; i++)
            inData[i] = (byte) in[i];
        try {
            StringBuffer md5hash = new StringBuffer("");
            MessageDigest mDigest = MessageDigest.getInstance("MD5");
            int byteCounter, tmpValue;
            Byte tmpByte;
      
            // Create the MD5 hash.
            mDigest.update(inData);
            byte[] mdBytes = mDigest.digest();
            int[] result = new int[mdBytes.length];
            for (int i=0; i<mdBytes.length; i++)
                result[i] = (mdBytes[i] + 256) % 256;
            return result;
        } catch(NoSuchAlgorithmException e) {
          	e.printStackTrace();
            // Return null on failure.
            return null;
        }
	}
}
